Bug 91421 - Doing away with xorg.conf for r128 x.org DDX device driver
Summary: Doing away with xorg.conf for r128 x.org DDX device driver
Status: RESOLVED MOVED
Alias: None
Product: xorg
Classification: Unclassified
Component: Driver/rage128 (show other bugs)
Version: 7.6 (2010.12)
Hardware: x86 (IA32) Linux (All)
: medium minor
Assignee: Xorg Project Team
QA Contact: Xorg Project Team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-07-22 02:34 UTC by Kevin Brace
Modified: 2018-08-10 20:50 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments
The minimalist xorg.conf that currently works with r128 x.org DDX device driver (210 bytes, text/plain)
2015-07-22 02:37 UTC, Kevin Brace
no flags Details
The shortest xorg.conf I got r128 x.org DDX device driver to work with Ubuntu 10.04 (86 bytes, text/plain)
2015-07-27 14:11 UTC, Kevin Brace
no flags Details
Xorg.0.log when I booted Ubuntu 10.04 with the shortest xorg.conf I got so far (41.52 KB, text/plain)
2015-07-27 14:16 UTC, Kevin Brace
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Kevin Brace 2015-07-22 02:34:15 UTC
Hi,

I have discussed this in Bug #91113, but I have experimented with how little of xorg.conf I can have so that I can boot X server.
I will attach the xorg.conf I used shortly, but I have cut down to very few lines of code.
Since I have cut down to such few lines of code, is there a way to make the DDX device driver loading automatic so that the use of xorg.conf itself can be discontinued for r128?
Of course, if the user wants to use it for some reason (i.e., change color depth to 16-bit rather than 24-bit), it should still be available, but for a default situation where it does not exist, the device driver should load properly without xorg.conf.
    Another reason for my request for the discontinuation of the use of xorg.conf is that if that file is missing, X server does not start at all.
This is very "user hostile" in my opinion.
Furthermore, OpenChrome device driver (there are occasionally some code being added to the device driver) for VIA Technologies integrated graphics hardware does not require the use of xorg.conf at all.

Regards,

Kevin Brace
Comment 1 Kevin Brace 2015-07-22 02:37:30 UTC
Created attachment 117289 [details]
The minimalist xorg.conf that currently works with r128 x.org DDX device driver

This is the fewest lines I have gotten it to.
I may be able to get rid of "Load  "glx"" line (Line 3), but it will be nice if the use of xorg.conf can be optional for a default (device driver automatic configuration) use.
Comment 2 Connor Behan 2015-07-23 21:44:35 UTC
By demanding xorg.conf, the code is being hostile to the user. But by buying an r128 card, the user is being hostile to himself. I'm not aware of any UMS drivers actually having this feature (OpenChrome can do UMS and KMS). Porting the r128 kernel module to KMS is still something on my todo list, so I'd rather wait until then.
Comment 3 Kevin Brace 2015-07-27 14:11:42 UTC
Created attachment 117396 [details]
The shortest xorg.conf I got r128 x.org DDX device driver to work with Ubuntu 10.04

This is the The shortest xorg.conf I got r128 x.org DDX device driver to work with Ubuntu 10.04.
Comment 4 Kevin Brace 2015-07-27 14:16:53 UTC
Created attachment 117397 [details]
Xorg.0.log when I booted Ubuntu 10.04 with the shortest xorg.conf I got so far
Comment 5 Kevin Brace 2015-07-27 14:39:10 UTC
(In reply to Connor Behan from comment #2)

I attached an even more minimalist xorg.conf to this bug report.
Please note that I was able to boot Ubuntu 10.04 successfully with that xorg.conf.
I think if the DDX device driver can assume a default DRI mode, then that portion can be eliminated from xorg.conf.
Is there also a way to get X server to pick the correct device driver for the graphics card it has identified?
If this is possible, then 'Identifier  "Card0"' portion can be eliminated.
I feel like the device driver is very close to being able to operate without xorg.conf.
    Generally speaking, the computing industry has moved towards automatic settings in the past 20 years (i.e., Plug & Play was a big deal with Windows 95), so eliminating the necessity to use xorg.conf should be considered.
Of course, it is okay to provide an option to override the default settings,  but at least the device driver should be designed in a way to be able to operate without a settings file.
That is why I filed this bug report in the first place.
As I have shown, the device driver itself is very close to being able to operate without xorg.conf, and besides, it used to be able to operate without xorg.org around 2010.


> By demanding xorg.conf, the code is being hostile to the user. But by buying
> an r128 card, the user is being hostile to himself. I'm not aware of any UMS
> drivers actually having this feature (OpenChrome can do UMS and KMS).
> Porting the r128 kernel module to KMS is still something on my todo list, so
> I'd rather wait until then.
Comment 6 Connor Behan 2015-07-27 18:22:14 UTC
(In reply to Kevin Brace from comment #5)
> (In reply to Connor Behan from comment #2)
> 
> I attached an even more minimalist xorg.conf to this bug report.
> Please note that I was able to boot Ubuntu 10.04 successfully with that
> xorg.conf.
> I think if the DDX device driver can assume a default DRI mode, then that
> portion can be eliminated from xorg.conf.

I think that will require DRI changes beyond just what is in the DDX. DRI1 is dead right now, so getting the driver to stop using that (long term) is a better plan.

> Is there also a way to get X server to pick the correct device driver for
> the graphics card it has identified?
> If this is possible, then 'Identifier  "Card0"' portion can be eliminated.
> I feel like the device driver is very close to being able to operate without
> xorg.conf.
>     Generally speaking, the computing industry has moved towards automatic
> settings in the past 20 years (i.e., Plug & Play was a big deal with Windows
> 95), so eliminating the necessity to use xorg.conf should be considered.
> Of course, it is okay to provide an option to override the default settings,
> but at least the device driver should be designed in a way to be able to
> operate without a settings file.
> That is why I filed this bug report in the first place.
> As I have shown, the device driver itself is very close to being able to
> operate without xorg.conf, and besides, it used to be able to operate
> without xorg.org around 2010.

I really don't know why X cares so much about "Card0" being present. If you can find the specific 2010-era commit where this changes occurred, I'd be interested.
Comment 7 Christopher Chavez 2016-01-03 05:02:30 UTC
[Likely off-topic.] Following what I've discussed on bug 91622, the iMac G3 will unfortunately always require an xorg.conf since there is no DDC/EDID for the internal display. The way Apple gets these monitors working with their OSes is likely through detecting the model via firmware; such a detection is probably beyond the scope of an xorg driver, let alone UNIX philosophy.

The other way of getting such models to work "out of the box" would likely be a third party utility that performs such a detection and applies the appropriate xorg.conf.
Comment 8 Christopher M. Penalver 2016-02-25 21:49:59 UTC
Kevin Brace, Ubuntu 10.04 Desktop reached EOL on May 9, 2013. For more on this, please see https://wiki.ubuntu.com/Releases .

If this is reproducible in a supported release, it will help immensely if you filed a new report with Ubuntu by ensuring you have the package xdiagnose installed, and that you click the Yes button for attaching additional debugging information running the following from a terminal:
ubuntu-bug xorg

Also, please feel free to subscribe me to it.

For more on why this is helpful, please see https://wiki.ubuntu.com/ReportingBugs.
Comment 9 Connor Behan 2016-02-26 05:49:39 UTC
This is not an Ubuntu bug tracker...
Comment 10 Christopher M. Penalver 2016-02-26 06:34:41 UTC
(In reply to Connor Behan from comment #9)
> This is not an Ubuntu bug tracker...

Thanks for that, but I am already aware.

Despite this, given the original reporter originally reported with an insecure/EOL OS as previously documented, hasn't posted anything on a supported release, and hasn't posted for 6+ months, it doesn't seem a great idea to encourage folks to use software that will endanger the data security of their system, and those around them. Let alone, burdening upstream with a downstream software support request.

However, as you have a different take here, I'll leave this report as you like.
Comment 11 Connor Behan 2016-04-18 17:12:30 UTC
Thanks, those are all valid points. However, with this particular issue, I can confidently say that the OP will experience it no matter which distro he uses as long as the monitor doesn't change.

I don't have strong feelings about keeping this bug open. The main reason I might want to refer to it is because of the astute comment by Chavez above which explains why the need for manual configuration is the fault of certain vendors and not Xorg developers :).
Comment 12 GitLab Migration User 2018-08-10 20:50:30 UTC
-- GitLab Migration Automatic Message --

This bug has been migrated to freedesktop.org's GitLab instance and has been closed from further activity.

You can subscribe and participate further through the new bug through this link to our GitLab instance: https://gitlab.freedesktop.org/xorg/driver/xf86-video-r128/issues/5.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.